###
#
# QMORE(input, maxlen)
# inserts a span into `input` after `maxlen` number of characters and returns it.
#
DROP FUNCTION IF EXISTS QMORE;
DELIMITER //
CREATE FUNCTION QMORE ( input TEXT, maxlen INT )
RETURNS TEXT DETERMINISTIC
BEGIN
DECLARE output TEXT;
IF maxlen < 1 THEN
SET maxlen = 1;
END IF;
IF CHAR_LENGTH(input) > maxlen THEN
SET output = CONCAT(INSERT(input, maxlen, 0, '<span class="qfq-more-text">'), '</span>');
ELSE
SET output = input;
END IF;
RETURN output;
END; //
DELIMITER ;


###
#
# QBAR(input)
# replaces '|' in `input` with '\|'
#
DROP FUNCTION IF EXISTS QBAR;
DELIMITER //
CREATE FUNCTION QBAR ( input TEXT )
RETURNS TEXT DETERMINISTIC
BEGIN
DECLARE output TEXT;
SET output = REPLACE(input, '|', '\\|');
RETURN output;
END; //
DELIMITER ;